﻿(function () {
    var cmp = app.project.activeItem;
    var selLyrs = cmp.selectedLayers;
    var allLyrs = cmp.layers;
    
    var TLFolders = getTLFolders( selLyrs );
    //If you want to move to normal AE operation, just return.
    if( TLFolders.length === 0 ){ return;}

    //You can get the modifier keys from the setting. A, S, and CS are available.
    //A : Alt or Option
    //S ; Shift
    //CS ; Ctrl+Shift or Cmd+Shift
    var modifierKey = app.settings.getSetting("WQPro", "modifier");
    if (modifierKey === "") {
        app.beginUndoGroup("");
        var isCollapsed = isCollapsedNow(TLFolders[0], allLyrs);
        for (var i = 0; i < TLFolders.length; i++) {
            var TLLyrs = getTLLyrs(TLFolders[i], allLyrs);
            setShy( TLLyrs, !isCollapsed );
            setTLFolderName(TLFolders[i], !isCollapsed);
        }
        cmp.hideShyLayers = true;
        app.endUndoGroup();
    }else if(modifierKey === "A"){
        app.beginUndoGroup("");
        for (var i = 0; i < TLFolders.length; i++) {
            var TLLyrs = getTLLyrs(TLFolders[i], allLyrs);
            selectTLLyrs( TLLyrs );
        }
        app.endUndoGroup();
    }else if(modifierKey === "S"){
        app.beginUndoGroup("Fit TLFolders");
        var cmpDur = cmp.duration;
         var isSameInOutsNow = isSameInOuts( TLFolders[0], allLyrs, cmp.frameDuration );
        for (var i = 0; i < TLFolders.length; i++) {
            var TLLyrs = getTLLyrs(TLFolders[i], allLyrs);
            fitTLFolder( TLFolders[i], TLLyrs, cmpDur, !isSameInOutsNow );
        }
        app.endUndoGroup(); 
    } else {
        //The setting "stopDefaultCommand" is always "false" unless you change it.
        //So, for normal AE operations, just return.
        return;
    }
    //To stop normal AE operation, set this setting to "true".
    //This setting automatically reverts to "false" when the script is finished processing.
    app.settings.saveSetting("WQPro", "stopDefaultCommand", "true");
    return;
    //--------------------------------------------------------------------------------
    //--------------------------------------------------------------------------------
    //Functions used.
    function getTLFolders(aSelLyrs) {
        var TLFolders = [];
        for (var i = 0; i < aSelLyrs.length; i++) {
            if( isTLfolder(aSelLyrs[i]) ){ TLFolders.push(aSelLyrs[i]);}
        }
        return TLFolders;
    }
    //--------------------------------------------------------------------------------
    function getTLLyrs(aTLFolder, aAllLyrs) {
        if( aTLFolder.index === aAllLyrs.length ){ return [];}
        var TLLyrs = [];
        for (var i = aTLFolder.index+1; i <= aAllLyrs.length; i++) {
            if( isTLfolder(aAllLyrs[i]) ){ break;}
            TLLyrs.push( aAllLyrs[i] );
        }
        return TLLyrs;
    }
    //--------------------------------------------------------------------------------
    function isTLfolder(aLyr) {
        if (!aLyr.hasOwnProperty ("effect")){ return false; }
        if (aLyr.effect.numProperties === 0){ return false; }
        if( aLyr.effect.property(1).name !== "TLFolder" ){return false; }
        return true;
    }
    //--------------------------------------------------------------------------------
    function isCollapsedNow(aTLFolder, aAllLyrs) {
        if( aTLFolder.index === aAllLyrs.length ){ return true;}
        return aAllLyrs[aTLFolder.index+1].shy;
    }
    //--------------------------------------------------------------------------------
    function setShy(aTLLyrs, aVal) {
        for (var i = 0; i < aTLLyrs.length; i++) { aTLLyrs[i].shy = aVal;}
    }
    //--------------------------------------------------------------------------------
    function setTLFolderName(aTLFolder, aAddCollapsedName) {
        var name = aTLFolder.name;
        name = name.replace(/(_v|_>) *[0-9]*$/, "");
        if (aAddCollapsedName) { aTLFolder.name = name + "_>";  }
        else { aTLFolder.name = name + "_v";}
    }
    //--------------------------------------------------------------------------------
    function selectTLLyrs( aTLLyrs ){
        for (var i = 0; i < aTLLyrs.length; i++) { aTLLyrs[i].selected = true;}
    }
    //--------------------------------------------------------------------------------
    function fitTLFolder( aTLFolder, aTLLyrs, aCmpDur, aFitOnOut){
        if(!aFitOnOut){
            aTLFolder.inPoint = 0;
            aTLFolder.outPoint = aCmpDur;
            return;
        }
        if( aTLLyrs.length === 0 ){ return;}
        aTLLyrs.sort( function(a,b){ return a.inPoint - b.inPoint;} );
        var minIn = aTLLyrs[0].inPoint;
        aTLLyrs.sort( function(a,b){ return b.outPoint - a.outPoint;} );
        var maxOut = aTLLyrs[0].outPoint;
        aTLFolder.inPoint = minIn;
        aTLFolder.outPoint = maxOut;
    }
    //--------------------------------------------------------------------------------
    function isSameInOuts( aTLFolder, aAllLyrs, aOneFrame ){
        var TLLyrs = getTLLyrs(aTLFolder, aAllLyrs);
        if( TLLyrs.length === 0 ){ return true;}
        TLLyrs.sort( function(a,b){ return a.inPoint - b.inPoint;} );
        var minIn = TLLyrs[0].inPoint;
        TLLyrs.sort( function(a,b){ return b.outPoint - a.outPoint;} );
        var maxOut = TLLyrs[0].outPoint;
        var isSameIn = (Math.abs(minIn - aTLFolder.inPoint) <  aOneFrame);
        var isSameOut = (Math.abs(maxOut - aTLFolder.outPoint) <  aOneFrame);
        return ( isSameIn && isSameOut );
    }
})();

